--Mostly declares objects. Objects initialize some values, and have general 'methods' such as: draw, update, which are called from the main loop.
--they also can contain not-general methods (such as: bounce) which can be called from wherever and changes values of the object
--Objects should be able to live on their own. They can contain function calls to the outside world, but the outside world also can contain calls to
--the objects



--bricks-load
brick_img = love.graphics.newImage('brick.png')
brick2_img = love.graphics.newImage('brick2.png')
double_brick_img1 = love.graphics.newImage('hard_brick1.png')
double_brick_img2 = love.graphics.newImage('hard_brick2.png')
brick_snd = love.audio.newSource('bubble.wav')
burning_brick_img1 = love.graphics.newImage('burning_brick1.png')
burning_brick_img2 = love.graphics.newImage('burning_brick2.png')
burning_brick_img3 = love.graphics.newImage('burning_brick3.png')
--BRICK1
brick = class('brick')
function brick:initialize(xi,yi)
self.xx = xi
self.yy = yi
self.box=HC.addRectangle(self.xx+5,self.yy+3,132,58)
end

function brick:draw()
love.graphics.draw(brick_img,self.xx,self.yy)
end
function brick:doStuff()
--dummy, called when a collission with ball occurs
love.audio.play(brick_snd)
end


--BRICK2
brick2 = class('brick')
function brick2:initialize(xi,yi,which_item)
self.Item = which_item
self.xx = xi
self.yy = yi
self.box=HC.addRectangle(self.xx+5,self.yy+3,128,64)
end

function brick2:draw()
love.graphics.draw(brick2_img,self.xx,self.yy,0,0.5,0.5)

end

function brick2:doStuff()
if self.Item == 1 then
table.insert(Items,live:new(self.xx,self.yy))
elseif self.Item == 2 then
table.insert(Items,speedup:new(self.xx,self.yy))
end
love.audio.play(brick_snd)
end
--BURNING BRICK
b_brick=class('b_brick')
function b_brick:initialize(xi,yi)
self.xx = xi
self.yy = yi
self.current_image = 1
self.Time = love.timer.getTime()
self.box=HC.addRectangle(self.xx+5,self.yy+3,132,58)
end

function b_brick:draw()
--animation
if self.current_image == 1 then
local gettime = love.timer.getTime
if gettime()-self.Time > 0.3 then
self.current_image = 2
self.Time=gettime()
end
love.graphics.draw(burning_brick_img1,self.xx,self.yy-40)
elseif self.current_image == 2 then
local gettime = love.timer.getTime
if gettime()-self.Time > 0.3 then
self.current_image = 3
self.Time=gettime()
end
love.graphics.draw(burning_brick_img2,self.xx,self.yy-40)
elseif self.current_image == 3 then
local gettime = love.timer.getTime
if gettime()-self.Time > 0.3 then
self.current_image = 1
self.Time=gettime()
end
love.graphics.draw(burning_brick_img3,self.xx,self.yy-40)
end
-- -----------------------------
end
function b_brick:doStuff()
--dummy, called when a collission with ball occurs
love.audio.play(brick_snd)
particles_fire:setPosition( self.xx, self.yy )
particles_fire:start()
end

--DOUBLE BRICK
double_brick = class('double_brick')
function double_brick:initialize(xi,yi,which_img)
self.xx = xi
self.yy = yi
self.which = which_img
if which_img == 1 then
self.img = double_brick_img1
elseif which_img == 2 then
self.img = double_brick_img2
end
self.box=HC.addRectangle(self.xx+5,self.yy+3,132,58)
end

function double_brick:draw()
love.graphics.draw(self.img,self.xx,self.yy)
end
function double_brick:doStuff()
--dummy, called when a collission with ball occurs
love.audio.play(brick_snd)

if self.which == 1 then
table.insert(bricks,double_brick:new(self.xx,self.yy,2))
end
end





--END_OF_BRICKSSSSS
--BALL
ball=class('ball')
function ball:initialize(xi,yi)
self.rotation = 0
self.rotation_speed = 3
self.ball_img=love.graphics.newImage('ball.png')
self.x=xi
self.y=yi
self.xto = 1
self.yto = 1
self.speed = 200
self.box=HC.addRectangle(self.x,self.y,32,32)
end

function ball:draw()
love.graphics.draw(self.ball_img,self.x,self.y, self.rotation,1,1,16,16)
end

function ball:move(dt)


self.rotation = self.rotation + self.rotation_speed*dt
if self.rotation_speed > 0 then
self.rotation_speed = self.rotation_speed - 3*dt
end
self.x = self.x + self.xto*dt*self.speed
self.y = self.y + self.yto*dt*self.speed
self.box:moveTo(self.x,self.y)

end
-- ]]]]]]]]]]]]]]]bounce function
function ball:bounce(xi,yi)
self.rotation_speed = self.rotation_speed +10
if self.yto == 1 and self.x>xi and self.y<yi  then
self.yto= (-1)
self:move(0.01)
elseif self.yto == (-1) and self.x>xi and self.y>yi then
self.yto = 1
self:move(0.01)
elseif self.xto == 1 and self.x<xi and self.y>yi then
self.xto = (-1)
self:move(0.01)
elseif self.xto == (-1) and self.x>xi and self.y>yi then
self.xto = 1
self:move(0.01)
end
end


--PADDLE
paddle=class('paddle')
function paddle:initialize(xi,yi)
love.mouse.setVisible(false)
self.paddle_img=love.graphics.newImage("bat.png")
self.x=xi
self.y=yi
self.xto = 40
self.yto = 40
self.box=HC.addRectangle(self.x,self.y,256,45)
end

function paddle:draw()
love.graphics.draw(self.paddle_img,self.x,self.y)
end

function paddle:move(dt)
local xx = love.mouse.getPosition()
--calculation so the mouse position works in every resolution
xx = xx*(1280/screen.x)
xx = xx-128
if xx > 50 and xx < 900  then
self.x = xx
end
self.box:moveTo(self.x+128,self.y+22.5)
self.box.x = self.x+128
self.box.y = self.y+22.5
end

--[Item] LIVE
live_image = love.graphics.newImage('live.png')
live = class('live')
function live:initialize(xx,yy)
self.x = xx
self.y = yy
self.box =HC.addRectangle(self.x,self.y,64,64)
self.w_height = 1280
end

function live:update(dt)
self.y = self.y+100*dt
self.box:moveTo(self.x+16,self.y+16)

--check if collides with bat.

if self.box:collidesWith(bat.box)then

--Add live :D
lives.lives = lives.lives+1

--Destroy self.
local x,y
for x,y in pairs(Items) do
if y == self then 
table.remove(Items,x)
end
end
end


--check if outside screen and DESTROYYYY
if self.y > self.w_height then
local x,y
for x,y in pairs(Items) do
if y == self then 
table.remove(Items,x)
end
end
end
--end function
end

function live:draw()
love.graphics.draw(live_image,self.x,self.y,0,0.5,0.5)
end
--[Item] SPEEDUP
speedup_image = love.graphics.newImage('speedup.png')
speedup = class('speedup')
function speedup:initialize(xx,yy)
self.x = xx
self.y = yy
self.box =HC.addRectangle(self.x,self.y,64,64)
self.w_height = 1280
end

function speedup:update(dt)
self.y = self.y+200*dt
self.box:moveTo(self.x+16,self.y+16)

--check if collides with bat.

if self.box:collidesWith(bat.box)then

--Add speed :D
ballball.speed = ballball.speed+100

--Destroy self.
local x,y
for x,y in pairs(Items) do
if y == self then 
table.remove(Items,x)
end
end
end


--check if outside screen and DESTROYYYY
if self.y > self.w_height then
local x,y
for x,y in pairs(Items) do
if y == self then 
table.remove(Items,x)
end
end
end
--end function
end

function speedup:draw()
love.graphics.draw(speedup_image,self.x,self.y,0,0.5,0.5)
end




--LIVES BAR
livesbar = class('livesbar')
function livesbar:initialize()
self.x = 10
self.y = 10
self.lives=3
end

function livesbar:draw()
for i=1,self.lives,1 do
love.graphics.draw(live_image,self.x+32*i,self.y,0,0.1,0.1)
end
end

--Simple particle burster.
PP = class('PP')
function PP:initialize(xi,yi)
create_particle_system(xi, yi)
end

function PP:draw()
end

function PP:update(dt)
particles_fire:update(dt)
end


